.de TP	\" An indented paragraph describing some command, tagged with the command name
.IP "\\f(CW\\$1\\fR" 5
.if \\w'\\f(CW\\$1\\fR'-4n .br
..
.de CI
.nr Sf \\n(.f
\%\&\\$3\f(CW\\$1\fI\&\\$2\f\\n(Sf
..
.de P2
..
.TL
Rc \(em La shell de Plan 9 
.AU
Tom Duff
td@plan9.bell-labs.com
.AB
.I Rc
es un intérprete de comandos para Plan 9 que proporciona facilidades similares a la shell Bourne de UNIX con algunas pequeñas adiciones y una sintaxis menos particular. Este documento usa numerosos ejemplos para describir las características de
.I rc 's
y tambien para contrastar 
.I rc
con la shell Bourne, un modelo con el que muchos lectores estarán familiarizados.
.AE
.NH
Introducción
.PP
.I Rc
es similar en espíritu pero diferente en detalle a la shell Bourne. Este documento describe las principales características de
.I rc
con muchos ejemplos cortos y algunos más largos.
Se asume algún conocimiento de la shell Bourne.
.NH
Comandos simples
.PP
Para los usos más simples
.I rc
tiene una sintaxis familiar para los usuarios de la shell Bourne. Se comporta como cabría esperar en todo esto:
.P1
date
cat /lib/news/build
who >user.names
who >>user.names
wc <file
echo [a-f]*.c
who | wc
who; date
vc *.c &
mk && v.out /*/bin/fb/*
rm -r junk || echo rm failed!
.P2
.NH
?????????
Quotation
Acotación
??????????
.PP
Un argumento que contiene un espacio o cualquiera de los otros sintácticos de
.I rc 's
debe ir encerrado entre apóstrofes
.CW ' ): (
.P1
rm 'odd file name'
.P2
Un apóstrofe en en un argumento acotado debe duplicarse:
.P1
echo 'How''s your father?'
.P2
.NH
Patrones
.PP
Un argumento no acotado que contiene cualquiera de los caracteres
.CW *
.CW ?
.CW [
es un patrón que puede hacerse coincidir con nombres de fichero.
Un carácter
.CW *
coincide con cualquier secuencia de caracteres,
.CW ?
coincide con un solo carácter, y
.CW [\fIclass\fP]
coincide con cualquier carácter de esa 
.CW clase ,
a no ser que el primer carácter de
.I class
sea
.CW ~ ,
en cuyo caso la clase está complementada.
La
.I clase
puede contener también pares de caracteres separados por 
.CW - ,
que representan a todos los caracteres que hay entre ambos.
El carácter
.CW /
debe aparecer explícitamente en un patrón, así como los componentes de un camino 
.CW .
y
.CW .. .
??????
Un patrón es reemplazado por una lista de argumentos, uno por cada camino que coincida, excepto que un patrón con el que no coincida ningún nombre, no se reemplaza con la lista vacía; en lugar de eso aparece como él mismo. 
A pattern is replaced by a list of arguments, one for each path name matched,
except that a pattern matching no names is not replaced by the empty list;
rather it stands for itself.
?????

.NH
Variables
.PP
La shell Bourne ofrece variables de tipo cadena.
.I Rc
proporciona variables cuyos valores son listas de argumentos \(em es decir, arrays de cadenas. Esta es la diferencia principal entre 
.I rc
y los intérpretes de comandos tradicionales de UNIX.
A las variables se les puede asignar valor por teclado, por ejemplo:
.P1
path=(. /bin)
user=td
font=/lib/font/bit/pelm/ascii.9.font
.P2
Los paréntesis indican que el valor asignado a
.CW path
es una lista de dos cadenas. A las variables
.CW user
y
.CW font
se les asignan listas que contienen una sola cadena.
.PP
El valor de una variable puede ser sustituido en un comando precediendo su nombre con un signo
.CW $ ,
como en:
.P1
echo $path
.P2
Si
.CW path
tiene asignado un valor, esto sería equivalente a
.P1
echo . /bin
.P2
Las variables pueden llevar índice, que puede ser un número o una lista de números.
como en:
.P1
echo $path(2)
echo $path(2 1 2)
.P2
Esto es equivalente a:
.P1
echo /bin
echo /bin . /bin
.P2
No puede haber ningún espacio separando el nombre de la variable del paréntesis izquierdo; de otro modo, los subíndices serín considerados una lista de números separada.
.PP
El número de cadenas en una variable puede ser determinado por el operador
.CW $#
Por ejemplo,
.P1
echo $#path
.P2
mostraría un 2 para este ejemplo.
.PP
Las dos siguientes asignaciones son sutilmente diferentes:
.P1
empty=()
null=''
.P2
La primera asigna a
.CW empty
una lista que no contiene ninguna cadena.
La segunda asigna a 
.CW null
una lista que contiene una sola cadena, pero que no tiene caracteres.
.PP
Aunque puede parecer que es más o menos lo mismo (en la shell Bourne lo es) se comportan de modo distinto en la mayoría de las ocasiones.
Entre otras cosas
.P1
echo $#empty
.P2
muestra 0, mientras que
.P1
echo $#null
.P2
muestra 1.
.PP
Todas las variables que no han sido asignadas tienen el valor
.CW () .
.PP
Ocasionalmente, es conveniente tratar el valor de una variable como una sola cadena. Los elementos de una lista son concatenados en una sola cadena, con espacios entre ellas mediante el operador 
.CW $"
 .
Así, si hacemos 
.P1
list=(How now brown cow)
string=$"list
.P2
entonces ambos
.P1
echo $list
.P2
y
.P1
echo $string
.P2
mostrarán la misma salida:
.P1
How now brown cow
.P2
pero
.P1
echo $#list $#string
.P2
mostrará
.P1
4 1
.P2
porque
.CW $list
tiene cuatro miembros, pero
.CW $string
tiene un solo miembro, con tres espacios separando sus palabras.
.NH
Argumentos
.PP
Cuando
.I rc
está leyendo su entrada desde un fichero, el fichero tiene acceso a los argumentos proporcionados en la linea de comando de
.I rc 
La variable
.CW $*
tiene asignada inicialmente la lista de argumentos. 
Los nombres
.CW $1 ,
.CW $2 ,
etc. son sinónimos de
.CW $*(1) ,
.CW $*(2) ,
etc.
Además
.CW $0
es el nombre del fichero desde el cual 
.I rc 
está leyendo la entrada.
.NH
Concatenación
.PP
.I Rc
tiene un operador de concatenación, el acento circunflejo, o caret
.CW ^ ,
para construir argumentos a partir de piezas.
.P1
echo hully^gully
.P2
es exactamente equivalente a
.P1
echo hullygully
.P2
Supongamos que la variable
.CW i
contiene el nombre de un comando.
Entonces,
.P1
vc $i^.c
vl -o $1 $i^.v
.P2
puede compilar el código fuente del comando, dejando el resultado en el fichero apropiado.
.PP
La concatenación es distributiva entre listas. Lo siguiente
.P1
echo (a b c)^(1 2 3)
src=(main subr io)
cc $src^.c
.P2
es equivalente a
.P1
echo a1 b2 c3
cc main.c subr.c io.c
.P2
Concretamente, la regla es: si ambos operandos de
.CW ^
son listas del mismo número de cadenas, mayor que cero, se concatenan uno a uno.
En otro caso, si uno de ellos es una sola cadena, se concatena con cada miembro del otro operando.
Cualquier otra combinación resulta en un error.
.NH
Circunflejos gratis 
.PP
Debido a las demandas de los usuarios
User demand has dictated that
.I rc
insertará circunflejos automáticamente en algunos lugares, para hacer que la sintaxis sea más parecida a la de la shell Bourne.
Por ejemplo, esto:
.P1
cc -$flags $stems.c
.P2
es equivalente a esto
.P1
cc -^$flags $stems^.c
.P2
En general,
.I rc
insertará
.CW ^
entre dos argumentos que no esten separados por un espacio en blanco.
Específicamente, siempre que alguno de estos caracteres, 
.CW "$'`
siga a una palabra acotada o no, o que una palabra no acotada siga a una acotada sin blancos ni tabuladores en medio, se insertará un 
.CW ^
entre ambos. Si una palabra no acotada que sigue a un signo 
.CW $
contiene algún caracter que no sea alfanumérico (salvo _ ó *) 
se insertará un 
.CW ^
antes del primer carácter.
.NH
Sustitución de comandos
.PP
A menudo es util construir una lista de argumentos a partir de la salida de un comando.
.I Rc
permite colocar un comando, acotado por llaves y precedido por un acento grave,
allows a command, enclosed in braces and preceded by a left quote,
.CW "`{...}" ,
en cualquier parte donde se requiera un argumento. El comando se ejecuta y su salida estandar es capturada.
Los caracteres almacenados en la variable
.CW ifs
se usan para dividir la salida en argumentos.
Por ejemplo,
.P1
cat `{ls -tr|sed 10q}
.P2
concatenerá los diez ficheros más antiguos del directorio actual por orden de fecha, usando el separador por defecto  
.CW ifs
que es un espacio, un tabulador o un  salto de linea.
.NH
Pipes con derivación
Pipeline branching
.PP
La notación normal de pipes es suficientemente general para todos los casos. Ocasionalmente, es útil tener pipes que no sean lineales. Las topologías de pipes, más genéricas que los árboles pueden requerir buffers de pipe extremadamente grandes, o peor aún, pueden causar interbloqueos.
.I Rc
Tiene una sintaxis para algunos tipos de pipes no lineales, sino en forma de árbol.
Por ejemplo,
.P1
	cmp <{old} <{new}
.P2
realizará un test de regresión de una nueva versión de un comando.
.CW <
ó 
.CW >
seguido de un comando entre llaves hace que el comando se ejecute con su entrada y su salida estandar enganchadas a un pipe. El comando padre,
.CW cmp "" (
??????????
en el ejemplo) se inicia con el otro lado del pipe enganchado a algun descriptor de fichero, y con un argumento que se conectará al pipe cuando sea abierto (por ejemplo
in the example)

is started with the other end of the pipe attached to some file descriptor
or other, and with an argument that will connect to the pipe when opened
(e.g.,
.CW /dev/fd/6 ).
?????????
Algunos comandos no estan preparados para trabajar con ficheros de entrada por los que no pueden desplazarse.
Por ejemplo
.CW diff
necesita leer su entrada dos veces.
.NH
Estado de salida
.PP
Cuando un comando termina devuelve su estado al programa que lo ejecutó. En Plan 9, el estado es una cadena que describe una condición de error. En una terminación normal, estará vacía.
.PP
.I Rc
captura el estado de salida de un comando en la variable
.CW $status .
Para un comando simple, el valor de
.CW $status
es simplemente como se ha descrito. Para una linea de pipes, a
.CW $status
se le asigna una concatenación de los estados de los componentes de la linea de pipes, entre caracteres 
.CW |
como separadores.
.PP
.I Rc
tiene varias clases de control de flujo, muchas de ellas condicionadas por el estado de retorno de los comandos ejecutados previamente. Cualquier
.CW $status
que contenga solamente valores
.CW 0 
separados por caracteres
.CW |
tiene el valor booleano de
.I true .
Cualquier otro estado es
.I false .
.NH
Agrupación de comandos
.PP
Una secuencia de comandos acotadas por
.CW {}
puede ser usada en cualquier parte donde se requiera un comando.
Por ejemplo:
.P1
{sleep 3600;echo 'Tiempo!'}&
.P2
espera una hora funcionando en segundo plano, y luego muestra un mensaje.
Sin las llaves
.P1
sleep 3600;echo 'Tiempo!'&
.P2
bloquearía el terminal durante una hora, y luego mostraría el mensaje en segundo plano.
.NH
Control de flujo \(em \f(CWfor\fP
.PP
Un comando puede ejecutarse una vez por cada miembro de una lista escribiendo, por ejemplo:
.P1
for(i in printf scanf putchar) look $i /usr/td/lib/dw.dat
.P2
Esto busca cada una de las palabras
.CW printf ,
.CW scanf
y
.CW putchar
en el fichero dado.
La forma general es
.P1
for(\fInombre\fP in \fIlista\fP) \fIcomando\fP
.P2
ó
.P1
for(\fInombre\fP) \fIcomando\fP
.P2
En el primer caso
.I comando
se ejecuta una vez para cada miembro de
.I lista
con ese miembro asignado a la variable
.I nombre.
Si la cláusula
.CW in "" ``
.I lista ''
no aparece, se asume
.CW in "" ``
.CW $* ''.
.NH
Ejecución condicional \(em \f(CWif\fP
.PP
.I Rc
también proporciona una sentencia general if. Por ejemplo:
.P1
for(i in *.c) if(cpp $i >/tmp/$i) vc /tmp/$i
.P2
ejecuta el compilador de C en cada fichero fuente que cpp procesa sin error.
Una sentencia `if not' proporciona las condicionales de dos caminos.
For example:
.P1
for(i){
    if(test -f /tmp/$i) echo $i ya está en /tmp
    if not cp $i /tmp
}
.P2
Esto se recorre cada fichero en 
.CW $* ,
copiando en 
.CW /tmp
los que no estén ya allí, y mostrando un mensaje para los que ya están.
.NH
Control de flujo \(em \f(CWwhile\fP
.PP
La sentencia while de  
.I Rc 
tiene la siguiente forma:
.P1
while(newer subr.v subr.c) sleep 5
.P2
Esto espera a que 
.CW subr.v
sea más nuevo que
.CW subr.c ,
presumiblemente debido a que el compilador de C lo termine.
.PP
Si el comando está vacío, el bucle no termina nunca.
Así,
.P1
while() echo y
.P2
emula el comando
.I yes.
.NH
Control de flujo \(em \f(CWswitch\fP
.PP
.I Rc
proporciona una sentencia switch para hacer coincidencia de patrones en cadenas arbitrarias. Su forma general es
.P1
switch(\fIpalabra\fP){
case \fIpatrón ...\fP
    \fIcommandos\fP
case \fIpatrón ...\fP
    \fIcommandos\fP
\&...
}
.P2
.I Rc
Intenta hacer coincidir la palabra con los patrones en cada sentencia case por turno.
Los patrones son iguales que los usados para nombres de ficheros, excepto que
.CW /
y
.CW .
y
.CW ..
no necesitan corresponderse explícitamente.
.PP
Si un patrón coincide, el comando que sigue a ese caso se ejecuta, y todos los siguientes hasta el siguiente case o hasta el final de la sentencia switch.
Por ejemplo,
.P1
switch($#*){
case 1
    cat >>$1
case 2
    cat >>$2 <$1
case *
    echo 'Usage: append [from] to'
}
.P2
es un comando append. Llamado con un nombre de fichero como argumento, agrega su entrada estandar al fichero. Con dos, el primero se agrega al segundo. Cualquier otro número implica un mensaje de error.
.PP
El comando interno
.CW ~
también hace coincidir patrones, y es, a menudo, más conciso que un switch.
Sus argumentos son una cadena y una lista de patrones. Pone
.CW $status
a true si y solo si alguno de los patrones coincide con la cadena.
El siguiente ejemplo procesa argumentos opcionales para el comando
.I man (1):
.P1
opt=()
while(~ $1 -* [1-9] 10){
    switch($1){
    case [1-9] 10
        sec=$1 secn=$1
    case -f
        c=f s=f
    case -[qwnt]
        cmd=$1
    case -T*
        T=$1
    case -*
        opt=($opt $1)
    }
    shift
}
.P2
.NH
Funciones
.PP
Las funciones pueden definirse escribiendo
.P1
fn \fInombre\fP { \fIcomandos\fP }
.P2
Posteriormente, cuando se encuentra un comando llamado
.I nombre 
el resto de la lista de argumentos del comando se asigna a
.CW $*
y
.I rc
ejecuta los
.I commandos .
El valor de
.CW $*
será restaurado una vez terminado.
Por ejemplo:
.P1
fn g {
    grep $1 *.[hcyl]
}
.P2
define
.CI g " patrón
para que busque ocurrencias de
.I patrón
en todos los ficheros fuentes del directorio actual.
.PP
Las definiciones de funciones son eliminadas escribiendo
.P1
fn \fInombre\fP
.P2
sin ningún cuerpo de función.
.NH
Ejecución de comandos
.PP
.I Rc
selecciona una acción entre varias acciones.
Si el nombre del comando es el de una funcion definida usando
.CW fn ,
se ejecuta la función.
Si no, si es el nombre de un comando interno, éste es ejecutado directamente por
.I rc .
Si no, se busca en los directorios mencionados en la variable
.CW $path
hasta encontrar un fichero ejecutable con ese nombre.
El uso intensivo de la variable
.CW $path
está desaconsejado en Plan 9. En su lugar, debe usarse el valor por defecto
.CW (.
.CW /bin)
y enlazar lo que se necesite en 
.CW /bin .
.NH
Comandos internos
.PP
Varios comandos son ejecutados internamente por
.I rc
debido a que son difíciles de implementar de otro modo.
.TP ". [-i] \fIfichero ...\f(CW
Ejecuta comandos de
.I fichero .
.CW $*
se asigna durante la ejecución con el valor de el resto de la lista de argumentos que siguen a 
.I fichero .
Se utiliza 
.CW $path
para buscar el 
.I fichero .
La opción
.CW -i
indica entrada interactiva \(em un prompt
(el valor de
.CW $prompt )
se muestra antes de leer cada comando.
.TP "builtin \fIcomando ...\f(CW
Ejecuta
.I comando
normalmente, excepto que se ignora cualquier función llamada
.I comando.
Por ejemplo,
.P1
fn cd{
    builtin cd $* && pwd
}
.P2
define una sustitución para el comando interno
.CW cd
(ver más abajo) que anuncia el nombre completo del nuevo directorio.
.TP "cd [\fIdir\f(CW]
Cambia el directorio actual a
.I dir .
El argumento por defecto es
.CW $home .
.CW $cdpath
es una lista de lugares en los que buscar 
.I dir .
.TP "eval [\fIarg ...\f(CW]
Los argumentos son concatenados (separados por espacios) en una cadena, leida como entrada para
.I rc ,
y ejecutada. Por ejemplo,
.P1
x='$y'
y=Doody
eval echo Howdy, $x
.P2
mostrará
.P1
Howdy, Doody
.P2
puesto que los argumentos de 
.CW eval
serán
.P1
echo Howdy, $y
.P2
después de la sustitución por
.CW $x .
.TP "exec [\fIcomando ...\f(CW]
.I Rc
se reemplaza a sí mismo con el 
.I command 
dado.
Esto es como un 
.I goto
\(em
.I rc
no espera a que el comando termine, y no vuelve a leer más comandos.\(em
.TP "exit [\fIestado\f(CW]
.I Rc
sale inmediatamente con el estado indicado. Si no se da ninguno, se usa el valor actual de
.CW $status.
.TP "flag \fIf\f(CW [+-]
Este comando manipula y comprueba las banderas de la linea de comandos (descritas más abajo)
.P1
flag \fIf\f(CW +
.P2
asigna la bandera 
.I f .
.P1
flag \fIf\f(CW -
.P2
borra la bandera
.I f .
.P1
flag \fIf\f(CW
.P2
comprueba la bandera
.I f ,
asignando valor a 
.CW $status
convenientemente.
Así,
.P1
if(flag x) flag v +
.P2
asigna la bandera
.CW -v
si la bandera
.CW -x
está ya asignada.
.TP "rfork [nNeEsfF]
Esto usa la entrada del sistema 
.I rfork
de Plan 9 para poner a
.I rc
en un nuevo grupo de procesos con los siguientes atributos:
.TS
box;
l l l
lfCW l l.
Bandera	Nombre	Función
_
n	RFNAMEG	Hace una copia del espacio de nombres del padre
N	RFCNAMEG	Empieza con un nuevo espacio de nombres vacío.
e	RFENVG	Hace una copia del entorno del padre
E	RFCENVG	Empieza con un nuevo entorno vacío.
s	RFNOTEG	Hace un nuevo grupo de notas
f	RFFDG	Hace una copia del espacio de descriptores de fichero del padre
F	RFCFDG	Hace un nuevo espacio de descriptores de fichero vacio	
.TE
La sección 
.I fork (2)
del Manual del Programador describe estos atributos con más detalle.
.TP "shift [\fIn\f(CW]
Borra los primeros
.I n
(por defecto 1) elementos de 
.CW $* .
.TP "wait [\fIpid\fP]
Espera a que el proceso con el 
.I pid
dado termine. Si no se dá ningún
.I pid
se espera por todos los procesos pendientes.
.TP "whatis \fInombre ...\f(CW
Muestra el valor de cada
.I nombre
en una forma aceptable como entrada para
.I rc .
Ls salida es una asignación a una variable, la definición de una función, una llamada 
.CW builtin
para un comando interno, o el camino hasta un programa.
Por ejemplo,
.P1
whatis path g cd who
.P2
podría mostrar
.P1
path=(. /bin)
fn g {gre -e $1 *.[hycl]}
builtin cd
/bin/who
.P2
.TP "~ \fIsujeto patrón ...\f(CW
El
.I sujeto
se hace coincidir con el 
.I patrón
por turno. En cada coincidencia, 
.CW $status
es puesto a true.
Si no hay coincidencias, es puesto a
.CW "'no match'" .
Los patrones son los mismos que los usados para nombres de ficheros.
Los
.I patrones
no estan sujetos a reemplazo de nombre de fichero antes de que el comando
.CW ~
se ejecuta, así que no necesitan acotarse con apóstrofes, a no ser, claro, que se requiera una coincidencia literal con 
.CW *
.CW [
o
.CW ?.
Por ejemplo.
.P1
~ $1 ?
.P2
coincide con un solo carácter, mientras que
.P1
~ $1 '?'
.P2
solo coincide con el signo de interrogación.
.NH
Redirección avanzada de E/S
.PP
.I Rc
permite la redirección de descriptores de ficheros distintos de 0 y 1 (entrada y salida estandar) especificando el descriptor entre corchetes
.CW "[ ]
después de
.CW <
ó
.CW > .
Por ejemplo,
.P1
vc junk.c >[2]junk.diag
.P2
salva los diagnósticos del compilador de la salida de error estandar en 
.CW junk.diag .
.PP
Los descriptores de fichero pueden reemplazarse por una copia, en el sentido de 
.I dup (2),
de un fichero abierto tecleando, por ejemplo
.P1
vc junk.c >[2=1]
.P2
Esto reemplaza el descriptor de ficheros 2 con una copia del descriptor 1. Es más útil en conjunción con otras redirecciones como esta:
.P1
vc junk.c >junk.out >[2=1]
.P2
Las redirecciones se evalúan de izquierda a derecha, así que esto redirige el descriptor de fichero 1 a 
.CW junk.out ,
y luego hace apuntar el descriptor 2 al mismo fichero.
Por el contrario,
.P1
vc junk.c >[2=1] >junk.out
.P2
redirige el descriptor 2 a una copia del descriptor 1 (presumiblemente la terminal), y luego redirige el descriptor 1 a un fichero. En el primer caso, las salidas estandar y de diagnóstico serán entremezcladas en 
.CW junk.out .
En el segundo, la salida de diagnóstico aparecerá en el terminal, y la salida estander será enviada al fichero.
.PP
Los descriptores de fichero pueden cerrarse usando la notación de duplicación con el lado derecho vacío.
Por ejemplo,
.P1
vc junk.c >[2=]
.P2
descartará los diagnósticos de la compilación.
.PP
Se pueden enviar a través de un pipe descriptores de fichero arbitrarios, por ejemplo,
.P1
vc junk.c |[2] grep -v '^$'
.P2
Esto borra las lineas en blanco de la salida de errores del compilador de C. Nótese que la salida de 
.CW grep
todavía aparece en el descriptor de fichero 1.
.PP
Ocasionalmente se puede querer conectar la entrada de un pipe a algún descriptor de fichero distinto de cero.
La notación
.P1
cmd1 |[5=19] cmd2
.P2
crea una tubería con el descriptor de fichero 5 de
.CW cmd1
conectado a través de un pipe al descriptor de fichero 19 de
file descriptor 5 connected through a pipe to
.CW cmd2.
.NH
Documentos aqui
.PP
Los procedimientos de
.I rc
pueden incluir datos, llamados ``documentos aqui'', que se proporcionan como entrada a los comandos, como en esta versión del comando
.I tel.
.P1
for(i) grep $i <<!
\&...
tor 2T-402 2912
kevin 2C-514 2842
bill 2C-562 7214
\&...
!
.P2
Un documento-aqui se introduce por medio del signo de redirección
.CW << ,
seguido de un marcador de EOF arbitrario.
.CW ! "" (
en el ejemplo). Las lineas que siguen al comando, hasta encontrar una linea que contiene solamente el marcador de EOF se salvan en un fichero temporal que se conecta a la entrada estandar del comando cuando se ejecuta.
.PP
.I Rc
hace sustituciones de variables en los documentos aqui. El siguiente comando:
.P1
ed $3 <<EOF
g/$1/s//$2/g
w
EOF
.P2
cambia todas las ocurrencias de
.CW $1
a
.CW $2
en el fichero
.CW $3 .
Para incluir un signo 
.CW $
literal en un documento-aqui, se usa
.CW $$ .
Si el nombre de la variable es seguido por un signo
.CW ^ ,
se elimina dicho signo.
.PP
La sustitución de variables puede suprimirse por completo acotando el marcador de EOF que sigue a
.CW <<
entre apóstrofes, como en 
.CW <<'EOF' .
.PP
Los documentos aqui pueden proporcionarse en descriptores de ficheros distintos de 0, por ejemplo,
.P1
cmd <<[4]End
\&...
End
.P2
.PP
Si un documento-aqui aparece dentro de un bloque compuesto, los contenidos del documento deben estar después del bloque completo:
.P1
for(i in $*){
	mail $i <<EOF
}
words to live by
EOF
.P2
.NH
Atrapando notas
.PP
Los guiones de
.I rc
terminan normalmente cuando una se recibe interrupción en la terminal. Una función con el nombre de una señal UNIX, en minúsculas, está definida como es usual, pero se llama cuando
.I rc
recibe la correspondiente nota.
La sección
.I notify (2)
del Manual del Programador explica las notas en más detalle.
Las notas de interes son:
.TP sighup
La nota era `hangup'.
Plan 9 la envia cuando el terminal se ha desconectado de 
.I rc .
.TP sigint
La nota era `interrupt', usualmente enviada cuando se teclea en el terminal el caracter de interrupción (DEL en ASCII).
.TP sigterm
La nota era `kill', normalmente enviada por
.I kill (1).
.TP sigexit
Una nota artificial enviada cuando
.I rc
está a punto de salir.
.PP
Como ejemplo,
.P1
fn sigint{
    rm /tmp/junk
    exit
}
.P2
coloca una trampa para la interrupción de teclado que borra un fichero temporal antes de salir.
.PP
Las notas serán ignoradas si la rutina de notas se pone a
.CW {} .
Las señales se revierten a su comportamiento por defecto cuando las definiciones de sus manejadores son borradas.
.NH
Entorno
.PP
El entorno es una lista de pares nombre-valor que está a disposición de los programas en ejecución.
En Plan 9, el entorno es almacenado en un sistema de ficheros llamado
.CW #e ,
normalmente montado en
.CW /env .
El valor de cada variable se almacena en un fichero separado, con componentes terminados por bytes cero.
(El sistema de ficheros se mantiene enteramente en memoria, así que no implica ningún acceso a disco o a la red)
Los contenidos de
.CW /env
se comparten en base a grupos por proceso \(mi cuando se crea un nuevo grupo de procesos, éste engancha  
.CW /env
a un nuevo sistema de ficheros inicializado con una copia del viejo.
Como consecuencia de esta organización, los comandos pueden cambiar entradas del entorno y ver los cambios reflejados en 
.I rc .
.PP
Las funciones también aparecen en el entorno, nombradas con el prefijo
.CW fn#
como 
.CW /env/fn#roff .
.NH
Variables locales
.PP
A veces es útil usar una variable solamente durante la ejecución de un comando. Una asignación seguida de un comando tiene ese efecto. Por ejemplo:
.P1
a=global
a=local echo $a
echo $a
.P2
mostrará
.P1
local
global
.P2
Esto funciona incluso con comandos compuestos, como
.P1
f=/nombre/de/un/fichero/largo {
    { wc $f; spell $f; diff $f.old $f } |
      pr -h 'Características de '$f | lp -dfn
}
.P2
.NH
Ejemplos \(em \fIcd, pwd\fP
.PP
Estas dos funciones proporcionan versiones mejoradas de los comandos estandar 
.CW cd
y
.CW pwd
(Gracias a Rob Pike.)
.P1
ps1='% '	# prompt por defecto
tab='	'	# un tabulador
fn cd{
  builtin cd $1 &&
  switch($#*){
  case 0
    dir=$home
    prompt=($ps1 $tab)
  case *
    switch($1)
    case /*
      dir=$1
      prompt=(`{basename `{pwd}}^$ps1 $tab)
    case */* ..*
      dir=()
      prompt=(`{basename `{pwd}}^$ps1 $tab)
    case *
      dir=()
      prompt=($1^$ps1 $tab)
    }
  }
}
fn pwd{
  if(~ $#dir 0)
    dir=`{/bin/pwd}
  echo $dir
}
.P2
La función
.CW pwd
es una versión del comando estandar
.CW pwd
que realiza un cacheo de su valor en la variable
.CW $dir ,
puesto que el auténtico 
.CW pwd
puede ser mucho más lento.
(Versiones recientes de Plan 9 tienen una implementación muy rápida de
.CW pwd ,
que reducen las ventajas de la función
.CW pwd).
.PP
La función
.CW cd
llama al comando interno
.CW cd
y comprueba que ha tenido éxito.
Si es así, pone
.CW $dir
y
.CW $prompt .
El prompt incluirá el último componente del directorio actual (excepto en el directorio home, en que será vacío) y 
.CW $dir
será reseteado o bien a su valor correcto o a 
.CW () ,
para que la función
.CW pwd
se ejecute correctamente.
.NH
Ejemplos \(em \fIman\fP
.PP
El comando
.I man
muestra páginas del Manual del Programador. Se llama, por ejemplo como 
.P1
man 2 sinh
man rc
man -t cat
.P2
En el primer caso, se mostrará la página de
.I sinh
en la sección 2.
En el segundo caso, se muestra la página del comando 
.I rc
Puesto que no se especifica sección, se busca en todas. En este caso se encuentra en la sección 1.
En el tercer caso, la página de 
.I cat
es mostrada con la opción
.CW -t.
.P1
cd /sys/man || {
  echo $0: No manual! >[1=2]
  exit 1
}
NT=n  # default nroff
s='*' # section, default try all
for(i) switch($i){
case -t
  NT=t
case -n
  NT=n
case -*
  echo Usage: $0 '[-nt] [section] page ...' >[1=2]
  exit 1
case [1-9] 10
  s=$i
case *
  eval 'pages='$s/$i
  for(page in $pages){
    if(test -f $page)
      $NT^roff -man $page
    if not
      echo $0: $i not found >[1=2]
  }
}
.P2
Obsérvese el uso de
.CW eval
para hacer una lista de páginas candidatas del manual.
Sin
.CW eval ,
el
.CW *
almacenado en 
.CW $s
no lanzaría la sustitución de nombres de fichero
\(em está acotado por apóstrofes, e incluso aunque no lo estuviera, sería expandido cuando se asignase a
.CW $s .
Eval hace que sus argumentos sean reprocesados por el analizador y el intérprete de 
.I rc 's
retardando la evaluación del 
.CW *
hasta su asignación a 
.CW $pages .
.NH
Ejemplos \(em \fIholmdel\fP
.PP
El siguiente guión
.I rc
juega al decepcionantemente simple juego 
.I holmdel ,
en el que los jugadores por turno nombran localizaciones de laboratorios Bell. El ganador es el primero que menciona Halmdel.
.KF
.P1
t=/tmp/holmdel$pid
fn read{
	$1=`{awk '{print;exit}'}
}
ifs='
\&'	# just a newline
fn sigexit sigint sigquit sighup{
	rm -f $t
	exit
}
cat <<'!' >$t
Allentown 
Atlanta
Cedar Crest
Chester
Columbus
Elmhurst
Fullerton
Holmdel
Indian Hill
Merrimack Valley
Morristown
Neptune
Piscataway
Reading
Short Hills
South Plainfield
Summit
Whippany
West Long Branch
!
while(){
   lab=`{fortune $t}
   echo $lab
   if(~ $lab Holmdel){
      echo You lose.
      exit
   }
   while(read lab; ! grep -i -s $lab $t) echo No such location.
   if(~ $lab [hH]olmdel){
      echo You win.
      exit
   }
}
.P2
.KE
.PP
Vale la pena describirlo en detalle
(más bien, valdría la pena si no fuese un juego tan tonto)
.PP
La variable
.CW $t
es una abreviación para el nombre del fichero temporal.
La inclusión de
.CW $pid ,
inicializado por
.I rc
con el id del proceso, en el nombre del fichero temporal asegura que no haya colisiones de nombres en caso de que más de unaa instancia del guión esten corriendo a la vez.
.PP
El argumento de la function
.CW read 
es el nombre de la variable en la que se lee la linea de entrada.
.CW $ifs
tiene como valor un salto de linea. Así, la entrada de
.CW read 
no se divide por espacios, pero el salto de linea final es borrado.
.PP
Se habilita un manejador para que atrape las señales
.CW sigint ,
.CW sigquit ,
y
.CW sighup,
y la señal artificial
.CW sigexit.
Simplemente borra el fichero temporal y sale.
.PP
El fichero temporal se inicializa desde un documento-aqui que contiene la lista de las localizaciones de los laboratorios Bell, y el bucle inicial comienza. 
.PP
Primero, el programa adivina el lugar (en
.CW $lab )
usando el programa 
.CW fortune
para tomar una linea al azar de la lista de lugares.
Muestra en pantalla el lugar y si ha adivinado Holmdel entonces muestra un mensaje y sale.
.PP
Luego usa la función
.CW read
para tomar lineas de la entrada estandar y validarlas hasta que consigue un nombre legal.
Nótese que la condición de un 
.CW while
puede ser un comando compuesto. Solo se comprueba el estado de salida del último comando de la secuencia.
.PP
Una vez más, si el resultado es Holmdel, muestra un mensaje y sale. Si no vuelve al inicio del bucle.
.NH
Principios de diseño.
.PP
.I Rc
debe mucho a la shell
.CW /bin/sh .
de Steve Bourne.
Cualquier sucesor suyo sufrirá en una comparación. He intentado arreglar sus limitaciones más conocidas, y simplificar las cosas lo más posible, usualmente omitiendo características no esenciales. Solamente cuando la tentación fué irresistible introduje ideas nuevas. Obviamente, he jugado bastante con la sintaxis de Bourne.
.PP
El principio más importante en el diseño de
.I rc 
es que no es un procesador de macros. La entrada nunca se escanea más de una vez con el código de análisis léxico y sintáctico (excepto, claro, para el comando
.CW eval
cuya razon de ser es romper esta regla)
.PP
Los guiones de la shell Bourne pueden a menudo ejecutarse erráticamente si se les pasan argumentos que contienen espacios.
Estos se dividen utilizando el valor de 
.CW IFS ,
a veces en lugares inoportunos.
En
.I rc ,
valores y variables, incluso argumentos de linea de comandos, no se releen cuando se sustituyen en un comando.
Se supone que el proceso padre ha escaneado los argumentos correctamente, así que no necesitamos releerlos.
.PP
¿Por qué la shell Bourne re-escanea los comandos después de la sustitución de variables?
Necesita poder guardar las listas de argumentos en variables cuyos valores son cadenas de caracteres.
Si eliminamos el re-escaneo, debemos cambiar los tipos de las variables, de modo que puedan contener listas de cadenas.
.PP
Esto introduce algunas complicaciones conceptuales. Necesitamos una notación para listas de palabras.
Hay dos tipos distintos de concatenación, para cadenas \(em
.CW $a^$b ,
y listas \(em
.CW "($a $b)" .
La diferencia entre
.CW ()
y
.CW ''
es confusa para los novatos, aunque su distinción es facil de argumentar \(em un argumento nulo no es lo mismo que la ausencia de argumentos.
.PP
Bourne también re-escanea la entrada cuando hace sustitución de comandos. Esto es debido a que el texto acotado entre acentos graves no es una cadena, sino un comando. Concretamente, debería ser analizado cuando es un comando, pero esto dificulta el manejo de sustituciones de comandos anidadas, como esta:
.P1
size=`wc -l \e`ls -t|sed 1q\e``
.P2
Los acentos graves internos deben ser escapados para evitar que terminen el comando externo. Pero, peor todavía, el número de
.CW \e 
requerido es exponencial con el nivel de anidamiento.
.I Rc
arregla esto haciendo que los acentos graves sean un operador unario, cuyo argumento es un comando, como este:
.P1
size=`{wc -l `{ls -t|sed 1q}}
.P2
No se necesitan escapes, y el elemento se analiza por completo en un solo paso.
.PP
Por razones similares
.I rc
defina manejadores de señales como si fuesen funciones, en lugar de asociar una cadena con cada señal como hace Bourne, con el riesgo añadido de obtener un mensaje de error de sintaxis como respuesta a teclear el carácter de interrupción.
Puesto que 
.I rc
analiza la entrada cuando se teclea, informa de los errores cuando se cometen.
.PP
Debido a toda esta problemática, ganamos simplificaciones semánticas sustanciales.
No se necesita diferenciar entre
.CW $*
y
.CW $@ .
No se necesitan cuatro tipos de acotación, ni las complejas reglas que las gobiernan. En
.I rc
se usan comillas cuando se necesita que un carácter de la sintaxis aparezca en un argumento, o cuando un argumento es una cadena vacía. En ningún caso más.
.CW IFS
ya no se usa, excepto en el caso en que era indispensable:
convertir la salida de un comando en listas de argumentos durante la sustitución de comandos.
.PP
Esto también evita un importante agujero de seguridad.
En UNIX, las llamadas del sistema
.I system
y
.I popen
llaman a
.CW /bin/sh
para ejecutar un comando. Es imposible usar cualquiera de ellas con la seguridad de que se ejecutará el comando específico, incluso si se especifica en las propias llamadas 
.I system
o 
.I popen
el camino completo del comando. Esto puede ser devastador si ocurre en un programa con userid.
El problema es que
.CW IFS
se usa para dividir el comando en palabras, así que el atacante simplemente tiene que poner
.CW IFS=/
en su entorno y dejar un troyano llamado
.CW usr
o
.CW bin
en el directorio actual antes de ejecutar el programa privilegiado.
.I Rc
soluciona esto evitando el re-escaneo de la entrada.
.PP
La mayoría de las demás diferencias entre
.I rc
y la shell de Bourne no son muy serias. He eliminado la peculiar forma de sustituir variables, como
.P1
echo ${a=b} ${c-d} ${e?error}
.P2
porque era muy poco usada, redundante y fácilmente expresable en términos más simples.
He eliminado los comandos internos
.CW export ,
.CW readonly ,
.CW break ,
.CW continue ,
.CW read ,
.CW return ,
.CW set ,
.CW times
y
.CW unset
porque eran redundantes o raramente útiles.
.PP
Mientras la sintaxis de Bourne copia de Algol 68,
.I rc
está más basado en C o en Awk. Esto es dificil de defender.
Creo que, por ejemplo
.P1
if(test -f junk) rm junk
.P2
es una sintaxis mejor que
.P1
if test -f junk; then rm junk; fi
.P2
porque está menos salpidado con palabras clave, evita signos de punto y coma, que Bourne requiere en lugares inadecuados, y los caracteres de sintaxis muestran más claramente las partes activas del comando.
.PP
La única parte importante de sintaxis que Bourne hace indudablemente mejor que  
.I rc
es la sentencia
.CW if
con una cláusula
.CW "else.
El
.CW if
de
.I Rc 
no tiene una llave final al estilo de
.CW fi.
Como resultado, el analizador no puede saber si esperar un
.CW "else
sin mirar su entrada por adelantado.
El problema es que después de leer, por ejemplo
.P1
if(test -f junk) echo junk found
.P2
en modo interactivo,
.I rc
no puede decidir si ejecutarlo inmediatamente e imprimir
.CW $prompt(1) ,
o imprimir
.CW $prompt(2)
y esperar a que se teclee el 
.CW "else.
en la shell de Bourne, esto no es un problema, debido a que el comando
.CW if
debe terminar con 
.CW fi ,
contenga un 
.CW else
o no.
.PP
La solución, aunque débil, de 
.I Rc
es declarar que la cláusula 
.CW else
es una sentencia separada, aunque obligada a seguir inmediatamente a un 
.CW if ,
y llamarse 
.CW "if not
en lugar de
.CW else ,
como recordatorio de que algo raro está pasando.
La única consecuencia notoria de esto es que las llaves se requieren en la construcción
.P1
for(i){
    if(test -f $i) echo $i found
    if not echo $i not found
}
.P2
y que
.I rc
resuelve la ambigüedad de los else perdidos, contrariamente a las expectativas de la mayoría de la gente.
.PP
Hay que tener en cuenta que en las cuatro ediciones más recientes del Manual del Programador de UNIX, la gramática de la shell de Bourne descrita no admite el comando
.CW who|wc .
Esto es, con seguridad, un descuido, pero sugiere algo más oscuro: nadie conoce realmente la gramática de la shell Bourne. Incluso el exámen del código fuente es de muy poca ayuda. El analizador está implementado por descendencia recursiva, pero las rutinas que corresponden a las categorías sintácticas tiene banderas como argumentos que cambian ligeramente su operación dependiendo del contexto.
El analizador de 
.I Rc
está implementado usando
.I yacc ,
así que puede verse con precisión cuál es su gramática.
.NH
Reconocimientos.
.PP
Rob Pike, Howard Trickey y otros usuarios de Plan 9 han sido fuentes incesantes e insistentes de buenas ideas y críticas. Algunos ejemplos de este documento están plagiados de [Bourne], así como la mayoría de las características buenas de 
.I rc.
.NH
Referencia
.LP
S. R. Bourne,
UNIX Time-Sharing System: The UNIX Shell,
Bell System Technical Journal, Volume 57 number 6, July-August 1978
